-- Object methods
-- Since: v0.4.1
local Obj = {VALID_OBJ = {}}

Obj.VALID_OBJ_MODEL = {
1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,
17,18,19,20,21,22,23,43,44,45,46,47,48,
49,50,51,52,53,54,55,56,57,58,59,60,61,
62,63,64,65,66,67,68,69,70,71,72,73,74,
75,76,77,78,79,80,81,82,83,84,85,86,87,
88,89,90,91,92,93,94,95,96,97,98,99,100,
110,111,112, -- Invisible obj
101,102,103,104,105,106,107,108,109,114,
117,118,119,120,121,123,128,134,135,136,
141,142,144,148,149,150,151,152,155,156,
157,158,163,164,170,174,175,182,183,184,
186,187,188,189,190,191,197,217,248,148,
240,247,249,250,252,253,254,255,295
}

--[[
function Obj.GetObjPos(obj)
	local x = 0
	local y = 0
	local z = 0
	if (obj ~= 0) then
		local obj_sprite_ptr = ReadProcessMemory(obj + 0x4, 4)
		x = ReadProcessMemory(obj_sprite_ptr + 0x14, 4) / 16384
		y = ReadProcessMemory(obj_sprite_ptr + 0x18, 4) / 16384
		z = ReadProcessMemory(obj_sprite_ptr + 0x1C, 4) / 16384
	end
	return x, y, z
end

function Obj.GetObjAngle(obj)
	local rotation = 0
	if (obj ~= 0) then
		local obj_sprite_ptr = ReadProcessMemory(obj + 0x4, 4)
		rotation = 360 * ReadProcessMemory(obj_sprite_ptr, 4) / 1439;
	end
	return rotation
end

function Obj.GetObjModel(obj)
	local obj_model = 0
	if (model >= 0 and model <= 65535) then
		if (obj ~= nil) then
			obj_model = ReadProcessMemory(obj + 0x18, 2)
		end
	end
	return obj_model
end

function Obj.SetObjAngle(obj, angle)
	if (obj ~= 0) then
		local obj_sprite_ptr = ReadProcessMemory(obj + 0x4, 4)
		WriteProcessMemory(obj_sprite_ptr, angle * 1439 / 360, 4)
	end
end

-- Work only z need obj sprite pointer?
function Obj.SetObjPos(obj, x, y, z)
	if (x >= 0 and x <= 255 and y >= 0 and y < 255 and z >= 0 and z <= 255) then
		if (obj ~= 0) then
			local obj_sprite_ptr = ReadProcessMemory(obj + 0x4, 4)
			WriteProcessMemory(obj_sprite_ptr + 0x14, x * 16384, 4)
			WriteProcessMemory(obj_sprite_ptr + 0x18, y * 16384, 4)
			WriteProcessMemory(obj_sprite_ptr + 0x1C, z * 16384, 4)
		end
	end
end
]]--

function Obj.IsValidModel(model)
	for i = 1, #Obj.VALID_OBJ_MODEL do
		if (Obj.VALID_OBJ_MODEL[i] == model) then
			return true
		end
	end
	return false
end

function Obj.GetObjSpriteID(obj)
	local obj_spriteid = 0
	if (obj ~= 0) then
		local obj_sprite_ptr = ReadProcessMemory(obj + 0x4, 4)
		obj_spriteid = ReadProcessMemory(obj_sprite_ptr + 0x22, 2)
	end
	return obj_spriteid
end

function Obj.SetObjSpriteID(obj, spriteid)
	if (spriteid >= 0 and spriteid <= 65535) then
		if (obj ~= 0) then
			local obj_sprite_ptr = ReadProcessMemory(obj + 0x4, 4)
			WriteProcessMemory(obj_sprite_ptr + 0x22, spriteid, 2) -- sprite id?
		end
	end
end

return Obj